package com.alag.ci.webcrawler;

import java.net.MalformedURLException;
import java.net.URL;

public class CrawlerUrl {
	private int depth = 0;
	private String urlString = null;
	private String title;
	private URL url = null;
	private boolean isAllowedToVisit;
	private boolean isCheckedForPermission = false;
	private boolean isVisited = false;

	public CrawlerUrl(String urlString, int depth) {
		this.depth = depth;
		this.urlString = urlString;
		computeURL();
	}

	private void computeURL() {
		try {
			url = new URL(urlString);
		} catch (MalformedURLException e) {
			// something is wrong
		}
	}

	public URL getURL() {
		return this.url;
	}
	
	public void setTitle(String title) {
		this.title = title;
	}
	
	public String getTitle() {
		return title;
	}

	public int getDepth() {
		return this.depth;
	}

	public boolean isAllowedToVisit() {
		return isAllowedToVisit;
	}

	public void setAllowedToVisit(boolean isAllowedToVisit) {
		this.isAllowedToVisit = isAllowedToVisit;
		this.isCheckedForPermission = true;
	}

	public boolean isCheckedForPermission() {
		return isCheckedForPermission;
	}

	public boolean isVisited() {
		return isVisited;
	}

	public void setIsVisited() {
		this.isVisited = true;
	}

	public String getUrlString() {
		return this.urlString;
	}

	@Override
	public String toString() {
		return this.urlString + " [depth=" + depth + " visit="
				+ this.isAllowedToVisit + " check="
				+ this.isCheckedForPermission + "]";
	}

	@Override
	public int hashCode() {
		return this.urlString.hashCode();
	}

	@Override
	public boolean equals(Object obj) {
		return obj.hashCode() == this.hashCode();
	}
}
