package com.alag.ci.webcrawler;

import java.util.LinkedList;
import java.util.List;
import java.util.Queue;

public class Main {
	public static void main(String[] args) {
		if (args.length != 5) {
			System.out.println("Lista de params: url, regexp, maxNumberUrls, "
					+ "maxDepth, delayBetweenUrls (in ms)");
			System.exit(1);
		}
		
		try {
			Queue<CrawlerUrl> urlQueue = new LinkedList<CrawlerUrl>();
			String url = args[0];
			String regexp = args[1];
			int maxNumberUrls = Integer.parseInt(args[2]);
			int maxDepth = Integer.parseInt(args[3]);
			long delayBetweenUrls = Integer.parseInt(args[4]);

			urlQueue.add(new CrawlerUrl(url, 0));
			NaiveCrawler crawler = new NaiveCrawler(urlQueue, maxNumberUrls,
					maxDepth, delayBetweenUrls, regexp);

			List<CrawlerUrl> urls = crawler.crawl();
			for (CrawlerUrl resultUrl : urls) {
				System.out.println(resultUrl.getTitle() + "|" + resultUrl.getUrlString());
			}
		} catch (Throwable t) {
			System.out.println(t.toString());
		}
	}
}